# 20.1.pbP[Wuggplot2vn
install.packages(c("ggplot2", "ggthemes", "dplyr", "scales"), dep=T)
library(ggplot2)
library(ggthemes)
library(dplyr)
library(scales)
library(grid)
library(gridExtra) 

head(ToothGrowth, n=3)

base   <- ggplot(ToothGrowth, aes(x=dose, y=len, color=supp))
points <- base + geom_point()
plot(points)
base + geom_point()   # plot(points) Ɠ

ggsave("TG.pdf", device="pdf", width=20, height=20, units="cm")

ggplot(ToothGrowth, aes(dose, len, color=supp)) +   # x= , y= ͏ȗ
  geom_point()



# 20.2.Ot̎
head(iris, n=3)

ggplot(iris, aes(Species, Petal.Length)) +
  geom_boxplot()

ggplot(iris, aes(Petal.Length)) +
  geom_histogram(aes(y = ..density..)) + 
  geom_density(color="black")

( M <- summarise(group_by(iris, Species), p=mean(Petal.Length)) )
ggplot(M, aes(Species, p)) +
  geom_bar(stat="identity")

ggplot(iris, aes(Sepal.Length, Sepal.Width)) +
  geom_point(aes(color=Species)) +
  stat_ellipse()

ggplot(iris, aes(Species, Petal.Length)) +
  geom_boxplot() +
  stat_summary(fun.y="mean", geom="point", shape=1, size=3)

ggplot(data.frame(x=c(-5,5)), aes(x)) +
  stat_function(fun=dnorm, args=list(mean=0, sd=1))

f <- function(x) 50 + x^3
g <- function(x) ifelse(x < -2, 50+x^3, NA)
ggplot(data.frame(x=c(-4,0)), aes(x)) + 
  stat_function(fun=g, geom="area", fill="pink") +
  stat_function(fun=f, color="red")



# 20.3.Ot̃JX^}CY
( TG <- summarise(group_by(ToothGrowth, supp, dose), m=mean(len), s=sd(len)) ) # dplyr pbP[W
pd <- position_dodge(.1)
ggplot(TG, aes(x=dose, y=m, color=supp)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.1, position=pd) +
  geom_line(position=pd) + geom_point(position=pd)

ggplot(TG, aes(x=dose, y=m, color=supp)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.1, position=pd) +
  geom_line(aes(linetype=supp), position=pd) + 
  geom_point(aes(shape=supp, fill=supp, size=supp), position=pd) + 
  scale_color_manual(values=c("red","blue")) +
  scale_linetype_manual(values=c("solid", "dashed")) +
  scale_shape_manual(values=c(2,19)) +
  scale_fill_manual(values=c("green","yellow")) +
  scale_size_manual(values=c(5,2)) +
  theme(legend.position=c(0.0,0.8), legend.justification=c(0,0)) +
  xlab("Dose") + ylab("Length") + ggtitle("Mean Plot") + 
  scale_x_continuous(limits=c(0.3,2.2), breaks=c(0.5,1,2), labels=c("0.5mg","1.0mg","2.0mg")) +
  scale_y_continuous(limits=c(0,40), breaks=seq(0,40,20), labels=c("0mm","20mm","40mm"))

ggplot(TG, aes(x=dose, y=m, color=supp)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.1, position=pd) +
  geom_line(position=pd) + geom_point(position=pd) + 
  annotate("text", x=1.8, y=8, label="2.0mg", col="green") + 
  annotate("segment", x=2, xend=2, y=10, yend=20, arrow=arrow(), col="green") +   # grid pbP[W
  annotate("pointrange", x=1.5, y=15, ymin=10, ymax=20, colour="green", size=2) +
  theme_classic()



# 20.4.Ђ낢
df <- data.frame(date=seq(Sys.Date(), len=50, by="1 day"), y=runif(50))
ggplot(df, aes(date,y)) + geom_line() + scale_x_date(labels=date_format("%Y/%m/%d")) # scales pbP[W

df <- data.frame(x=1:5, y=1:5)
mysqrt_trans <- function() trans_new("mysqrt", 
  function(x) sqrt(x), function(x) x^2) # ϊƋtϊ`
ggplot(df, aes(x=x, y=y)) + geom_point() + coord_trans(x="mysqrt")

( M <- summarise(group_by(iris, Species), 
         m=mean(Petal.Length), s=sd(Petal.Length)) )
ggplot(M, aes(x=Species, y=m)) +
  geom_errorbar(aes(ymin=m-s, ymax=m+s), width=.5) +
  geom_point() + coord_flip()

GO <- ggplot(iris, aes(Sepal.Length, Sepal.Width)) +
  geom_point(aes(color=Species))
TO <- tableGrob(iris[1:5,], rows=NULL, 
  theme=ttheme_minimal(core=list(fg_params=list(col=1, cex=1))))
grid.arrange(GO, TO, nrow=2, as.table=TRUE, heights=c(3,1))

ggplot(ToothGrowth, aes(len)) +
  geom_density(color="black") +
  facet_wrap(~ supp, ncol=2)

ggplot(ToothGrowth, aes(len)) +
  geom_density(color="black") +
  facet_grid(supp ~ dose)

( TG <- summarise(group_by(ToothGrowth, supp, dose), m=mean(len)) )
pd <- position_dodge(.1)
ggplot(TG, aes(x=factor(dose), y=m, color=supp)) +
  geom_line(position=pd)

ggplot(TG, aes(x=factor(dose), y=m, color=supp, group=supp)) +
  geom_line(position=pd)
